#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ar array

const int inf = 1e18;

struct Seg {
    int n;
    vector<int> t;
    Seg(vector<int> a) {
        n = a.size();
        t.assign(2 * n, inf);
        for (int i = 0; i < n; i++) {
            t[i + n] = a[i];
        }
        for (int i = n - 1; i >= 0; i--) {
            t[i] = min(t[2 * i], t[2 * i + 1]);
        }
    }
    int get(int l, int r) {
        l = max(l, 0LL);
        r = min(r, n - 1);
        int res = inf;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) {
                res = min(res, t[l++]);
            }
            if (!(r & 1)) {
                res = min(res, t[r--]);
            }
        }
        return res;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int n, m;
    cin >> n >> m;
    
    int l[m], r[m];
    
    vector<int> dp[2];
    dp[0].assign(n + 1, inf);
    
    cin >> l[0] >> r[0];
    
    for (int i = r[0] - l[0] + 1; i <= n; i++) {
        dp[0][i] = abs(i - r[0]);
    }
    
    int cur = 0;
    for (int j = 1; j < m; j++) {
        cur ^= 1;
        dp[cur].assign(n + 1, inf);
        cin >> l[j] >> r[j];
        int len = r[j] - l[j] + 1;
        Seg s(dp[cur ^ 1]);
        for (int i = len; i <= n; i++) {
            dp[cur][i] = abs(i - r[j]) + s.get(i - len + 1, i + (r[j - 1] - l[j - 1]));
        }
    }
    
    cout << *min_element(dp[cur].begin(), dp[cur].end()) << "\n";
}
