// -------------------- Includes -------------------- //
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>
#include <array>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <iterator>
#include <numeric>
#include <complex>
#include <tuple>
#include <utility>
#include <cassert>
#include <assert.h>
#include <climits>
#include <limits.h>
#include <ctime>
#include <time.h>
#include <random>
#include <chrono>
#include <fstream>
using namespace std;

// -------------------- Typedefs -------------------- //

typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;

// -------------------- Defines -------------------- //

#define pr pair
#define mpr make_pair
#define ff first
#define ss second

#define mset multiset
#define mmap multimap
#define uset unordered_set
#define umap unordered_map
#define umset unordered_multiset
#define ummap unordered_multimap
#define pqueue priority_queue

#define sz(x) (int((x).size()))
#define len(x) (int((x).length()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define clr(x) (x).clear()

#define pf push_front
#define pb push_back
#define popf pop_front
#define popb pop_back
#define ft front
#define bk back

#define lb lower_bound
#define ub upper_bound
#define bs binary_search

// -------------------- Constants -------------------- //

const int MAX = int(1e9 + 5);
const ll MAXL = ll(1e18 + 5);
const ll MOD = ll(1e9 + 7);
const ll MOD2 = ll(998244353);

// -------------------- Functions -------------------- //

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	return;
}

void precision(int x)
{
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(x);
	return;
}

ll gcd(ll a, ll b)
{
	if (a > b) {
		swap(a, b);
	}
	if (a == 0) {
		return b;
	}
	if (a == b) {
		return a;
	}
	return gcd(b % a, a);
}

ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

bool is_prime(ll a)
{
	if (a == 1) {
		return false;
	}
	ll i;
	for (i = 2; i * i <= a; i++) {
		if (a % i == 0) {
			return false;
		}
	}
	return true;
}

bool is_square(ll a)
{
	ll b = ll(sqrt(a));
	return (b * b == a);
}

bool is_cube(ll a)
{
	ll b = ll(cbrt(a));
	return (b * b * b == a);
}

int digit_sum(ll a)
{
	int sum = 0;
	while (a) {
		sum += int(a % 10);
		a /= 10;
	}
	return sum;
}

ll binpow(ll a, int b)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
		}
		b >>= 1;
		a *= a;
	}
	return ans;
}

ll binpow_by_mod(ll a, ll b, ll mod)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
			ans %= mod;
		}
		b >>= 1;
		a *= a;
		a %= mod;
	}
	return ans;
}

ll factorial(int a)
{
	int i;
	ll ans = 1;
	for (i = 2; i <= a; i++) {
		ans *= ll(i);
	}
	return ans;
}

ll factorial_by_mod(int a, ll mod)
{
	int i;
	ll ans = 1;
	for (i = 2; i <= a; i++) {
		ans *= ll(i);
		ans %= mod;
	}
	return ans;
}

// -------------------- Solution -------------------- //

/*const int N = 200005;
int a[N];
int n;*/

vector<vector<int>> t;

vector<pr<pr<int, int>, int>> v;

vector<vector<int>> dp;

vector<int> ddd;

void upd(int tl, int tr, int ind, int x, int v, int pos)
{
	if (tl == tr) {
		t[v][pos] = x;
		return;
	}
	int m = (tl + tr) / 2;
	if (ind <= m) {
		upd(tl, m, ind, x, v, pos * 2);
	}
	else {
		upd(m + 1, tr, ind, x, v, pos * 2 + 1);
	}
	t[v][pos] = min(t[v][pos * 2], t[v][pos * 2 + 1]);
	return;
}

int qry(int tl, int tr, int l, int r, int v, int pos)
{
	if (v == 0) {
		return 0;
	}
	if (l > r) {
		return MAX;
	}
	if (tl == l && tr == r) {
		return t[v][pos];
	}
	int m = (tl + tr) / 2;
	return min(qry(tl, m, l, min(m, r), v, pos * 2), qry(m + 1, tr, max(m + 1, l), r, v, pos * 2 + 1));
}

void solve()
{
	int i, j;
	int n, m;
	cin >> n >> m;
	v.pb(mpr(mpr(0, 0), 1));
	for (i = 1; i <= m; i++) {
		int a, b;
		cin >> a >> b;
		v.pb(mpr(mpr(a, b), b - a + 1));
	}

	for (j = 1; j <= m + 5; j++) {
		ddd.pb(0);
	}
	for (i = 1; i <= n + 5; i++) {
		dp.pb(ddd);
	}

	for (i = 1; i <= n; i++) {
		for (j = 1; j <= m; j++) {
			dp[i][j] = MAX;
		}
	}

	clr(ddd);
	for (i = 1; i <= n * 4 + 20; i++) {
		ddd.pb(MAX);
	}
	for (i = 1; i <= m + 5; i++) {
		t.pb(ddd);
	}

	int x, y;
	for (j = 1; j <= m; j++) {
		for (i = 1; i <= n; i++) {
			if (i + v[j].ss - 1 > n) {
				continue;
			}
			x = max(1, i - v[j - 1].ss + 1);
			y = min(n, i + v[j].ss - 1);
			dp[i][j] = min(dp[i][j], abs(i - v[j].ff.ff) + qry(1, n, x, y, j - 1, 1));
			upd(1, n, i, dp[i][j], j, 1);
		}
	}
	/*for (i = 1; i <= n; i++) {
		for (j = 1; j <= m; j++) {
			cout << dp[i][j] << ' ';
		}
		cout << endl;
	}*/
	int ans = MAX;
	for (i = 1; i <= n; i++) {
		ans = min(ans, dp[i][m]);
	}
	cout << ans << endl;
	return;
}

void precalc()
{
	return;
}

int main()
{
	fastio();

	precalc();

	int tests = 1, tc;
	//cin >> tests;
	for (tc = 1; tc <= tests; tc++) {
		solve();
	}

	//cout << db(clock()) / CLOCKS_PER_SEC << endl;

	return 0;
}

/*
	# # # #   # # # #   # # # #   #       #    #       #     #
	   #      #         #     #    #     #    # #      #   #
	   #      # # # #   #     #     #   #    #   #     # #
	   #            #   #     #      # #    # # # #    #   #
	   #      # # # #   # # # #       #    #       #   #     #
*/