#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define vi vector<int>
#define vll vector<ll>
#define pi pair<int, int>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvll vector<vll>
#define vvpll vector<vpll>
#define vvi vector<vector<int>>
#define vvc vector<vector<char>>
#define vc vector<char>
#define vb vector<bool>
#define vpi vector<pair<int, int>>
#define vvb vector<vb>
#define vvpi vector<vector<pair<int, int>>>
#define ios ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr)
#define all(vec) (vec).begin(), (vec).end()
#define rall(vec) (vec).rbegin(), (vec).rend()
#define sq(n) ((n) * (n))

int dx[] = {-1, 0, 1, 0};
int dy[] = {0, 1, 0, -1};

const ll INF = 1e18, P = 31;
const int inf = 1e9 + 1;
const ll mod = 1e9 + 7;
int MAX_C = 26;

class DSU {
public:
    vi size, pre;
    int comps;

    explicit DSU(int n) {
        size.assign(n + 1, 1);
        pre.resize(n + 1);
        for (int i = 1; i <= n; i++) pre[i] = i;
        comps = n;
    }

    int get_pre(int a) {
        if (pre[a] != a) pre[a] = get_pre(pre[a]);
        return pre[a];
    }

    bool merge(int a, int b) {
        a = get_pre(a);
        b = get_pre(b);
        if (a == b) return false;
        if (size[a] < size[b]) swap(a, b);
        pre[b] = a;
        size[a] += size[b];
        comps--;
        return true;
    }
};

inline ll fast_pow(ll a, ll p) {
    if (p == 0) return 1;
    ll res = fast_pow(a, p / 2);
    if (p % 2) return (res * res) % mod * a % mod;
    return (res * res) % mod;
}

struct ans {
    int val1 = inf, par1 = -1, val2 = inf, par2 = -1;

    void upd(int val, int par) {
        if (val <= val1) {
            if (par != par1) {
                val2 = val1;
                par2 = par1;
            }
            val1 = val;
            par1 = par;
        } else if (val < val2 and par != par1) {
            val2 = val;
            par2 = par;
        }
    }
};

pair<int, pi> ask(int l, int r) {
    cout << "? " << l << " " << r << endl;
    ll s, l_, r_;
    cin >> s >> l_ >> r_;
    return {s, {l_, r_}};
}

void solve() {
    int n;
    cin >> n;
    vector<set<int>> bad(n + 1);
    vi result(n + 1);
    vi pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        int length = 1;
        for (int el: bad[i]) {
            if (el == length) {
                length++;
            } else {
                break;
            }
        }
        auto res = ask(i - length + 1, i);
        bad[res.second.second].insert(res.second.second - res.second.first + 1);
        if (length > 1) {
            int tmp_sum = pref[i - 1] - pref[i - length];
            res.first -= tmp_sum;
        }
        result[i] = res.first;
        pref[i] = pref[i - 1] + res.first;
    }
    cout << "!" << endl;
    for (int i = 1; i <= n; i++) cout << result[i] << " ";
    cout << endl;
}

signed main() {
    cout.precision(20);
    ios;
    int t;
    t = 1;
   // cin >> t;
    while (t--) {
        solve();
    }
}