#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define vi vector<int>
#define vll vector<ll>
#define pi pair<int, int>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvll vector<vll>
#define vvpll vector<vpll>
#define vvi vector<vector<int>>
#define vvc vector<vector<char>>
#define vc vector<char>
#define vb vector<bool>
#define vpi vector<pair<int, int>>
#define vvb vector<vb>
#define vvpi vector<vector<pair<int, int>>>
#define ios ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr)
#define all(vec) (vec).begin(), (vec).end()
#define rall(vec) (vec).rbegin(), (vec).rend()
#define sq(n) ((n) * (n))

int dx[] = {-1, 0, 1, 0};
int dy[] = {0, 1, 0, -1};

const ll INF = 1e18, P = 31;
const int inf = 1e9 + 1;
const ll mod = 1e9 + 7;
int MAX_C = 26;

class DSU {
public:
    vi size, pre;
    int comps;

    explicit DSU(int n) {
        size.assign(n + 1, 1);
        pre.resize(n + 1);
        for (int i = 1; i <= n; i++) pre[i] = i;
        comps = n;
    }

    int get_pre(int a) {
        if (pre[a] != a) pre[a] = get_pre(pre[a]);
        return pre[a];
    }

    bool merge(int a, int b) {
        a = get_pre(a);
        b = get_pre(b);
        if (a == b) return false;
        if (size[a] < size[b]) swap(a, b);
        pre[b] = a;
        size[a] += size[b];
        comps--;
        return true;
    }
};

struct Node {
    ll min_val = INF, pushed_val = INF;
};

class SegmentTree {
private:
    vector<Node> tree;
    int n;

    void push(int i) {
        ll tmp = tree[i].pushed_val;
        tree[i * 2].min_val = min(tree[i * 2].min_val, tmp);
        tree[i * 2].pushed_val = min(tree[i * 2].pushed_val, tmp);
        tree[i * 2 + 1].min_val = min(tree[i * 2 + 1].min_val, tmp);
        tree[i * 2 + 1].pushed_val = min(tree[i * 2 + 1].pushed_val, tmp);
    }

    void upd(int i, int tl, int tr, int l, int r, ll val) {
        if (tl == l and tr == r) {
            tree[i].pushed_val = min(tree[i].pushed_val, val);
            tree[i].min_val = min(tree[i].min_val, val);
            return;
        }
        int tm = (tl + tr) / 2;
        push(i);
        if (r <= tm) upd(i * 2, tl, tm, l, r, val);
        else if (l > tm) upd(i * 2 + 1, tm + 1, tr, l, r, val);
        else {
            upd(i * 2, tl, tm, l, tm, val);
            upd(i * 2 + 1, tm + 1, tr, tm + 1, r, val);
        }
        tree[i].min_val = min(tree[i * 2].min_val, tree[i * 2 + 1].min_val);
    }

    ll get_min(int i, int tl, int tr, int l, int r) {
        if (tl == l and tr == r) return tree[i].min_val;
        int tm = (tl + tr) / 2;
        push(i);
        if (r <= tm) return get_min(i * 2, tl, tm, l, r);
        else if (l > tm) return get_min(i * 2 + 1, tm + 1, tr, l, r);
        else {
            return min(get_min(i * 2, tl, tm, l, tm),
                       get_min(i * 2 + 1, tm + 1, tr, tm + 1, r));
        }
    }

public:
    void upd(int l, int r, ll val) {
        if (l > r) return;
        upd(1, 0, n - 1, l, r, val);
    }

    ll get_min(int l, int r) {
        return get_min(1, 0, n - 1, l, r);
    }

    explicit SegmentTree(int size) {
        tree.resize(4 * size);
        n = size;
    }
};

void solve() {
    int n, m, l, r;
    cin >> n >> m;
    vpi lines(m);
    for (int i = 0; i < m; i++) {
        cin >> l >> r;
        lines[i] = {l - 1, r - l + 1};
    }

    SegmentTree pre(n);
    for (int i = 0; i < m; i++) {
        if (i == 0) {
            for (int j = 0, end = lines[i].second - 1; end < n; j++, end++) {
                ll delta = abs(lines[i].first - j);
                pre.upd(j, end, delta);
            }
        } else {
            SegmentTree st(n);
            for (int j = 0, end = lines[i].second - 1; end < n; j++, end++) {
                ll delta = abs(lines[i].first - j);
                st.upd(j, end, delta + pre.get_min(j, end));
            }
            pre = st;
        }
    }

    cout << pre.get_min(0, n - 1) << '\n';
}

signed main() {
    cout.precision(20);
    ios;
    int t;
    t = 1;
    //  cin >> t;
    while (t--) {
        solve();
    }
}