#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define vi vector<int>
#define vll vector<ll>
#define pi pair<int, int>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvll vector<vll>
#define vvpll vector<vpll>
#define vvi vector<vector<int>>
#define vvc vector<vector<char>>
#define vc vector<char>
#define vb vector<bool>
#define vpi vector<pair<int, int>>
#define vvb vector<vb>
#define vvpi vector<vector<pair<int, int>>>
#define ios ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr)
#define all(vec) (vec).begin(), (vec).end()
#define rall(vec) (vec).rbegin(), (vec).rend()
#define sq(n) ((n) * (n))

int dx[] = {-1, 0, 1, 0};
int dy[] = {0, 1, 0, -1};

const ll INF = 1e18, P = 31;
const int inf = 1e9 + 1;
const ll mod = 1e9 + 7;
int MAX_C = 26;

class DSU {
public:
    vi size, pre;
    int comps;

    explicit DSU(int n) {
        size.assign(n + 1, 1);
        pre.resize(n + 1);
        for (int i = 1; i <= n; i++) pre[i] = i;
        comps = n;
    }

    int get_pre(int a) {
        if (pre[a] != a) pre[a] = get_pre(pre[a]);
        return pre[a];
    }

    bool merge(int a, int b) {
        a = get_pre(a);
        b = get_pre(b);
        if (a == b) return false;
        if (size[a] < size[b]) swap(a, b);
        pre[b] = a;
        size[a] += size[b];
        comps--;
        return true;
    }
};

inline ll fast_pow(ll a, ll p) {
    if (p == 0) return 1;
    ll res = fast_pow(a, p / 2);
    if (p % 2) return (res * res) % mod * a % mod;
    return (res * res) % mod;
}

struct ans {
    int val1 = inf, par1 = -1, val2 = inf, par2 = -1;

    void upd(int val, int par) {
        if (val <= val1) {
            if (par != par1) {
                val2 = val1;
                par2 = par1;
            }
            val1 = val;
            par1 = par;
        } else if (val < val2 and par != par1) {
            val2 = val;
            par2 = par;
        }
    }
};

bool ok(char c) {
    return c == 'a' or c == 'e' or c == 'i' or c == 'o' or c == 'u';
}

int f(string word) {
    int res = (ok(word[0]));
    for (int i = 1; i < word.size(); i++) {
        if (ok(word[i]) and !ok(word[i - 1])) {
            res++;
        }
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    vector<int> arr(n);
    string tmp;
    for (int i = 0; i < n; i++) {
        cin >> tmp;
        arr[i] = f(tmp);
    }
    int res = 0;
    for (int i = 0; i < n; i++) {
        int cur_sum = arr[i];
        int j = i;
        while (cur_sum < 5) {
            if (j == n - 1) cur_sum = inf;
            else cur_sum += arr[++j];
        }
        if (cur_sum != 5 or j == n - 1) continue;
        cur_sum = arr[++j];
        while (cur_sum < 7) {
            if (j == n - 1) cur_sum = inf;
            else cur_sum += arr[++j];
        }
        if (cur_sum != 7 or j == n - 1) continue;
        cur_sum = arr[++j];
        while (cur_sum < 5) {
            if (j == n - 1) cur_sum = inf;
            else cur_sum += arr[++j];
        }
        if (cur_sum != 5) continue;
        res++;
    }
    cout << res << '\n';
}

signed main() {
    cout.precision(20);
    ios;
    int t;
    t = 1;
   // cin >> t;
    while (t--) {
        solve();
    }
}