﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ctype.h>
#include <deque>
#include <cstring>
#include <set>
#include <bitset>
#include <map>
#include <chrono>
#include <random>
#include <unordered_map>
#include <stdio.h>

using namespace std;

//╱╱╭━╮╭━┳━━━┳━╮╱╱╱╱╱╱╭━┳━━━┳━╮╭━╮
//╱╭╯╭╋╯╭┫╭━╮┣╮╰╮╱╱╱╱╭╯╭┫╭━╮┣╮╰╋╮╰╮
//╭╯╭╋╯╭╯┃┃┃┃┃╰╮╰┳╮╭┳╯╭╯┃┃┃┃┃╰╮╰╋╮╰╮
//┃┃┃┃┃┃╱┃┃┃┃┃╱┃┃┃╰╯┃┃┃╱┃┃┃┃┃╱┃┃┃┃┃┃
//┃┃┃┃┃┃╱┃╰━╯┃╱┃┃┣╮╭┫┃┃╱┃╰━╯┃╱┃┃┃┃┃┃
//╰╮╰╋╮╰╮╰━━━╯╭╯╭╯╰╯╰╮╰╮╰━━━╯╭╯╭╋╯╭╯
//╱╰╮╰╋╮╰╮╱╱╱╭╯╭╯╱╱╱╱╰╮╰╮╱╱╱╭╯╭╋╯╭╯
//╱╱╰━╯╰━╯╱╱╱╰━╯╱╱╱╱╱╱╰━╯╱╱╱╰━╯╰━╯


//F(x) = (6 - x)(x(1 - t) + 2t - 1);
//x0 = (7 - 8t) / (2(1 - t));
//Q = max(F(1), F(2) и F(x0) если 1 <= x0 <= 2)
//Вернуть Q * 100 * T / 6
//t = X / 100
//X, T t = X / 100

double f(double x, double t) {
    return (6 - x) * (x * (1 - t) + 2 * t - 1);
}

void solveK() {
    long long X, T;
    cin >> X >> T;
    double q;
    double t = double(X) / 100;
    if (X == 100) {
        q = max(f(1, t), f(2, t));
        cout << q * 100 * T / 6;
        return;
    }
    
    double x0 = (7 - 8 * t) / (2 * (1 - t));
    
    if (1 <= x0 && x0 <= 2) {
        q = max(f(x0, t), max(f(1, t), f(2, t)));
    }
    else {
        q = max(f(1, t), f(2, t));
    }
    cout << q * 100 * T / 6;
}

bool chekGlas(char a) {
    if (a == 'a') { return true; }
    if (a == 'e') { return true; }
    if (a == 'i') { return true; }
    if (a == 'o') { return true; }
    if (a == 'u') { return true; }
    return false;
}

int colSlog(string str) {
    int sol = 0;
    string arr = 'c' + str;
    for (int i = 1; i < arr.size(); ++i) {
        if (!chekGlas(arr[i - 1]) && chekGlas(arr[i])) {
            ++sol;
        }
    }
    return sol;
}

bool chekHokku(vector<int> arr, int i) {
    int colSlogLokal = 0;
    while (colSlogLokal < 5 && i < arr.size()) {
        colSlogLokal += arr[i];
        ++i;
    }
    if (colSlogLokal != 5) {
        return false;
    }

    while (colSlogLokal < 12 && i < arr.size()) {
        colSlogLokal += arr[i];
        ++i;
    }
    if (colSlogLokal != 12) {
        return false;
    }

    while (colSlogLokal < 17 && i < arr.size()) {
        colSlogLokal += arr[i];
        ++i;
    }
    if (colSlogLokal != 17) {
        return false;
    }
    return true;
}

void solveE() {
    vector<int> arr;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string str;
        cin >> str;
        int col = colSlog(str);
        if (col > 0) {
            arr.push_back(col);
        }
    }

    int sol = 0;
    for (int i = 0; i < arr.size(); ++i) {
        if (chekHokku(arr, i)) {
            ++sol;
        }
    }
    cout << sol;

}
void solve() {
    solveK();
}

int main() {
    ios_base::sync_with_stdio(false);
    srand((unsigned int)time(nullptr));
    cout.setf(ios::fixed);
    cout.precision(9);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) { solve(); }

    return (0 - 0); //;(
}