#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>

using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &out, vector<T> v) {
    for (T e : v) {
        out << e << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &e : v) {
        in >> e;
    }
    return in;
}

int log2(int n) {
    int k = 0;
    while ((1ll << k) < n) {
        k++;
    }
    return k - ((1ll << k != n));
}

struct Sparse {
    vector<vector<int>> data;
    explicit Sparse(const vector<int> &a) {
        int n = (int)a.size();
        int layers = log2(n) + 1;
        data.assign(layers, vector<int>(n));
        data[0] = a;
        for (int i = 1; i < layers; ++i) {
            for (int j = 0; j <= n - (1 << i); ++j) {
                data[i][j] = min(data[i - 1][j], data[i - 1][j + (1 << (i / 2))]);
            }
        }
    }

    int get(int l, int r) {
        int layer = log2(r - l);
        return min(data[layer][l], data[layer][r - (1 << layer)]);
    }
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    vector<int> s(m);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        a[i] = r - l;
        s[i] = l;
    }
    dbg(s);
    dbg(a);
    vector<vector<int>> dp(m, vector<int>(n, 1e9));
    for (int i = 0; i < n; ++i) {
        dp[0][i] = abs(i - s[0]);
    }
    for (int i = 1; i < m; ++i) {
        Sparse sparse(dp[i - 1]);
        dbg(i);
        for (int j = 0; j <= n - a[i]; ++j) {
            dbg(max(0, j - a[i - 1] + 1));
            dbg(min(n - a[i - 1] + 1, j + a[i]));
            dp[i][j] = sparse.get(max(0, j - a[i - 1] + 1), min(n - a[i - 1] + 1, j + a[i])) + abs(s[i] - j);
        }
    }

    dbg(dp);
    cout << *min_element(all(dp[m - 1])) << "\n";
}


signed main() {
    cout.precision(16);
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    freopen("../A.in", "r", stdin);
    // freopen("../A.out", "w", stdout);
#endif
    solve();
    return 0;
}
