#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()

const int inf = 1e9;

const double eps = 1e-8;
bool lo(double a, double b) {
	return a - b < -eps;
}

double X, T;
double get(double t, double k, double b) {
	return k * t + b;
}

int main() {
	cin >> X >> T;

	double ans = 0;
	ans = max(ans, (T - T / 3.) * get(T / 3., 0, 100));
	ans = max(ans, (T - T / 6.) * get(T / 6., 6. * X / T, 0));

	double k = 6 * (100 - X) / T;

	double l = T / 6, r = T / 3;
	for (int _ = 0; _ < 1000; _++) {
		double len = r - l + eps;
		double m1 = l + len / 3, m2 = l + 2 * len / 3;

		if ((T - m1) * (k * (m1 - T / 6) + X) < (T - m2) * (k * (m2 - T / 6) + X))
			l = m1;
		else
			r = m2;
	}

	ans = max(ans, (T - r) * (k * (r - T / 6) + X));
	cout << setprecision(7) << fixed << ans;

	return 0;
}