#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef vector<vector<pair<ll, char>>> graph_t;

const ll INF = 1e18;

void solve() {
    ll n, m;
    cin >> n >> m;
    graph_t g(n);
    while(m--) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].emplace_back(y, 0);
        g[y].emplace_back(x, 0);
    }
    ll f;
    cin >> f;
    vector<ll> d(n);
    for (auto& x : d) {
        cin >> x;
    }
    vector<ll> dist(n, -INF);
    vector<char> used(n, 0);
    dist[0] = (d[0] >= f ? f / 2 : f);
    set<pair<ll, ll>> q;
    q.insert({-dist[0], 0});
    while(!q.empty()) {
        auto p = *q.begin();
        q.erase(q.begin());
        ll v = p.second;
        if (used[v]) continue;
        used[v] = 1;
        for (auto x : g[v]) {
            ll cost = (d[x.first] >= dist[v] ? dist[v] / 2 : dist[v]);
            if (dist[x.first] < cost) {
                dist[x.first] = cost;
                q.insert({-dist[x.first], x.first});
            }
        }
    }
    cout << max(0ll, dist[n - 1]);
}


int main() {
    solve();
    return 0;
}
