#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#include <iomanip>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<vector<pair<ll, char>>> graph_t;

const ll INF = 1e18;


ll sign(ll x) {
    if (!x) return 0;
    return x / abs(x);
}

void gcd(ll a, ll b, vector<pair<ll, ll>>& ans) {
    while (a && b) {
        if (abs(a) % abs(b) == 0) {
            ans.push_back({1, -a / b});
            break;
        } else if (abs(b) % abs(a) == 0) {
            ans.push_back({2, -b / a});
            break;
        }

        if (abs(a) >= abs(b)) {
            ans.push_back({1, -a / b});
            a = a + b * (-a / b);
        } else {
            ans.push_back({2, -b / a});
            b = b + a * (-b / a);
        }
    }
}


void solve() {
    ll x, y;
    cin >> x >> y;
    if (x == 0 || y == 0) {
        cout << 0;
        return;
    }
    vector<pair<ll, ll>> ans;
    gcd(x, y, ans);
    vector<pair<ll, ll>> new_ans = {ans[0]};
    for (ll i = 1; i < ans.size(); i++) {
        if (ans[i].first == ans[i - 1].first) {
            new_ans.back().second += ans[i].second;
        } else {
            new_ans.push_back(ans[i]);
        }
    }
    cout << new_ans.size() << '\n';
    for (auto& s : new_ans) {
        cout << s.first << ' ' << s.second << '\n';
    }
}


int main() {
    solve();
    return 0;
}