#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#include <iomanip>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<vector<pair<ll, char>>> graph_t;

const ll INF = 1e18;


ll sign(ll x) {
    if (!x) return 0;
    return x / abs(x);
}

void gcd(ll a, ll b, vector<pair<ll, ll>>& ans) {
    while (a && b) {
        if (a > b) {
            ans.push_back({1, -a / b * -(sign(a) == sign(b))});
            a %= b;
        } else {
            ans.push_back({2, -b / a * -(sign(a) == sign(b))});
            b %= a;
        }
    }
}


void solve() {
    ll x, y;
    cin >> x >> y;
    vector<pair<ll, ll>> ans;
    gcd(abs(x), abs(y), ans);
    vector<pair<ll, ll>> new_ans = {ans[0]};
    for (ll i = 1; i < ans.size(); i++) {
        if (ans[i].first == ans[i - 1].first) {
            new_ans.back().second += ans[i].second;
        } else {
            new_ans.push_back(ans[i]);
        }
    }
    cout << new_ans.size() << '\n';
    for (auto& x : new_ans) {
        cout << x.first << ' ' << x.second << '\n';
    }
}


int main() {
    solve();
    return 0;
}