#include <iostream>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <random>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const ll arrS = 4 * ll(1e6) + 6666, inf = ll(1e18) + 18ll;
const ld eps = 0.00000001;

ifstream in("input.txt");
ofstream out("output.txt");

#define fast() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

struct point {
	ld x, y;
	point operator +(point other) {
		return { other.x + x, other.y + y };
	}
	point operator -(point other) {
		return { x - other.x, y - other.y };
	}
	point operator *(point other) {
		return { x * other.x, y * other.y };
	}
	ld operator ^(point other) {
		return (x * other.y - other.x * y);
	}
	ld operator %(point other) {
		return (x * other.x + y * other.y);
	}
};
ld len(point a) {
	return sqrt(a.x * a.x + a.y * a.y);
}

ll powMod(ll x, ll y, ll mod) {
	if (!y) return 1;
	ll z = powMod((x) % mod, (y / 2) % mod, mod);
	if (y % 2) return ((x) % mod * (z) % mod * (z) % mod) % mod;
	else return ((z) % mod * (z) % mod) % mod;
}

vector <ll> gcdPlus(ll a, ll b) {
	if (!a) return vector <ll> {b, 0, 1};
	vector <ll> tres(3); tres = gcdPlus(b % a, a);
	ll x = tres[2] - (b / a) * tres[1];
	ll y = tres[1];
	return vector <ll> { tres[0], x, y };
}
ll gcd(ll a, ll b) {
	while (a != 0 && b != 0) {
		if (a > b) a %= b;
		else b %= a;
	}
	return a + b;
}

ll lcm(ll a, ll b) {
	return a / max(1ll, gcd(a, b)) * b;
}

string downcase(string s) {
	for (ll i = 0; i < s.size(); i++) {
		if (s[i] >= 'A' && s[i] <= 'Z') {
			s[i] += 32;
		}
	}
	return s;
}

ll sum(ll n) {
	ll ans = 0;
	while (n > 0) {
		ans += n % 10;
		n /= 10;
	}
	return ans;
}

vector <pair <ll, ll>> fact(ll q) {
	vector <pair <ll, ll>> f;
	ll n = q;
	for (ll i = 2; i * i <= q; i++) {
		pair <ll, ll> t = { i, 0ll };
		while (!(n % i)) {
			n /= i;
			t.second++;
		}
		if (t.second) {
			f.push_back(t);
		}
	}
	if (n > 1) {
		f.push_back({ n, 1 });
	}
	return f;
}

ll C(ll n, ll k, ll mod) {
	vector <vector <ll>> ans(n + 1, vector <ll>(k + 1));
	for (ll i = 0; i <= n; i++) {
		ans[i][0] = 1;
	}
	for (ll i = 0; i <= min(n, k); i++) {
		ans[i][i] = 1;
	}
	for (ll i = 1; i <= n; i++) {
		for (ll j = 1; j < min(i, k + 1); j++) {
			ans[i][j] = (ans[i - 1][j - 1] + ans[i - 1][j]) % mod;
		}
	}
	return ans[n][k];
}

bool isPrime(ll n) {
	for (ll i = 2; i * i <= n; i++) {
		if (!(n % i)) {
			return false;
		}
	}
	return true;
}

ll mul(ll a, ll b, ll mod) {
	return (a * b) % mod;
}

ll add(ll a, ll b, ll mod) {
	a += b;
	if (a > mod) a -= mod;
	return a;
}

ll sub(ll a, ll b, ll mod) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

ld x, t;
ld check(ld f) {
	if (f >= t / 3.0) {
		return ld(t - f) * 100.0;
	}
	if (f <= t / 6.0) {
		return (t / 6.0) / f * x;
	}
	ld l = x, r = 100;
	for (ll i = 0; i < 1000; i++) {
		ld mf = (l + r) / 3;
		point c = { f - t / 6, mf }, a = { t / 6, x }, b = { t / 3, 100 };
		point fz = (c - a), sz = (b - a);
		bool flF = false, flS = false;
		if ((fz ^ sz) == 0) {
			flF = true;
		}
		ld ms = (l + r) / 3 * 2;
		c = { f - t / 6, ms }, a = { t / 6, x }, b = { t / 3, 100 };
		fz = (c - a), sz = (b - a);
		if ((fz ^ sz) == 0) {
			flS = true;
		}
		if (flF > flS) {
			r = flS;
		}
		else {
			l = flF;
		}
	}
	ld ans = t / 6 * x + (t / 3 - t / 6) * x + (t / 3 - t / 6) * l;
	return ans;
}

signed main() {
	fast();
	cin >> x >> t;
	ld l = -1, r = t + 1, ans = 0.0;
	for (ll i = 0; i < 1000; i++) {
		ld mf = (l + r) / 3.0, ms = (l + r) / 3.0 * 2.0;
		if (check(mf) < check(ms)) {
			l = mf;
		}
		else {
			r = ms;
		}
		ans = max(ans, max(check(mf), check(ms)));
	}
	cout << setprecision(10ll) << fixed << ans;
	return 0;
}