//
// Created by michael on 14.11.2021.
//

#include <bits/stdc++.h>
using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

typedef long long ll;

const int INF = 0x3f3f3f3f;
const ll LLINF = 0x3f3f3f3f3f3f3f3f;

const int MAXN = 1e5 + 5;
ll last[2 * MAXN];

void upd(int v, ll newval) {
    v += MAXN;
    last[v] = newval;
    v /= 2;
    while (v > 0) {
        last[v] = min(last[2 * v], last[2 * v + 1]);
        v /= 2;
    }
}

ll get(int l, int r) {
    l += MAXN, r += MAXN;
    ll ans = LLINF;
    while (l < r) {
        if (l & 1) ans = min(ans, last[l]);
        if (!(r & 1)) ans = min(ans, last[r]);
        l = (l + 1) / 2;
        r = (r - 1) / 2;
    }
    if (l == r) ans = min(ans, last[l]);
    return ans;
}

void solve() {
    int n, m;
    std::cin >> n >> m;
    fill(last, last + 2 * MAXN, LLINF);
    std::vector<ll> now(n);

    int lastlen = 1;
    for (int i = 0; i < m; i++) {
        for (int k = 0; k < n; k++) {
            upd(k, now[k]);
        }
        now.assign(n, INF);

        int s, t;
        std::cin >> s >> t;
        s--, t--;
        int len = t - s + 1;
        for (int j = 0; j < n; j++) {
            if (j + len - 1 >= n) continue;
            ll cost = std::abs(j - s);
            int left = std::max(0, j - lastlen + 1);
            int right = std::min(n - 1, j + lastlen - 1);
            cost += get(left, right);
            now[j] = min(now[j], cost);
        }
        lastlen = len;
    }

    std::cout << *std::min_element(all(now)) << '\n';
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
