#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>
using namespace std;

template <typename T> inline T getint() {
    T val = 0;
    char c;
    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }
    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));
    return val * (neg ? -1 : 1);
}

typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e4 + 13;
ll t[maxn * 4];
const ld eps = 1e-7;
map <pair <ll, ll>, pair <ll, ll>> st_by_st;
map <pair <ll, ll>, ll> st_by_v;
char used[maxn * 4];
vector<ll> ANS;


void build(ll v, ll tl, ll tr) {
    //cout << tl << " " << tr << endl;
    if (tl < tr - 1) {
        ll tm = (tl + tr) / 2;
        st_by_v[{tl, tm}] = 2 * v;
        st_by_v[{tm, tr}] = 2 * v + 1;
        st_by_st[{tl, tm}] = { tm , tr };
        st_by_st[{tm, tr}] = { tl , tm };
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm, tr);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

void build2(ll v, ll tl, ll tr) {
    if (tl < tr - 1) {
        ll tm = (tl + tr) / 2;
        if (!used[v * 2 + 1]) {
            t[v * 2 + 1] = t[v] - t[v * 2];
        }
        if (!used[v * 2]) {
            t[v * 2] = t[v] - t[v * 2 + 1];
        }
        build2(v * 2, tl, tm);
        build2(v * 2 + 1, tm, tr);
    }
}

void buildANS(ll v, ll tl, ll tr) {
    if (tl < tr - 1) {
        ll tm = (tl + tr) / 2;
        buildANS(v * 2, tl, tm);
        buildANS(v * 2 + 1, tm, tr);
    }
    else
        ANS.push_back(t[v]);
}

int main() {
    /*std::ios::sync_with_stdio(false);
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);*/
    fill(used, used + maxn * 4, 0);
    fill(t, t + maxn * 4, 0);
    ll n; cin >> n;
    build(1, 0, n);
    ll l = 0, r = n;
    cout << "? 1 " << n << endl;
    cout.flush();
    st_by_v[{0, n}] = 1;
    for (;;) {

        ll ans, ans_l, ans_r;
        cin >> ans >> ans_l >> ans_r; 
        if (st_by_v.count({ l, r }))
        {
            ll v = st_by_v[{l, r}];
            used[v] = 1;
            t[v] = ans;
        }
        if (st_by_st.count({ ans_l - 1, ans_r })) {
            
            l = st_by_st[{ ans_l - 1, ans_r }].first;
            r = st_by_st[{ ans_l - 1, ans_r }].second;
            cout << "? " << l + 1 << ' ' << r << endl;
            cout.flush();
            st_by_st.erase(st_by_st[{ ans_l - 1, ans_r }]);
            st_by_st.erase({ ans_l - 1, ans_r });
        } 
        else {
            pair <ll, ll> pr;
            if (st_by_st.size() == 0)
                break;
            for (auto pr_one : st_by_st) {
                pr = pr_one.second;
                break;
            }
            l = pr.first;
            r = pr.second;
            cout << "? " << l + 1 << ' ' << r << endl;
            cout.flush();
            st_by_st.erase(st_by_st[pr]);
            st_by_st.erase(pr);
        }
    }
    cout << "!\n";
    build2(1, 0, n);
    buildANS(1, 0, n);
    for (int i : ANS) {
        cout << i << " ";
    }
    cout.flush();
}
