#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>
using namespace std;

template <typename T> inline T getint() {
    T val = 0;
    char c;
    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }
    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));
    return val * (neg ? -1 : 1);
}

typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-7;

ll cnt_sl(string s) {
    ll sum = 0;
    for (ll i = 0; i < s.size(); ++i)
        if ((s[i] == 'a' || s[i] == 'e' || s[i] == 'i' || s[i] == 'o' || s[i] == 'u') && (i == 0 || (s[i - 1] != 'a' && s[i - 1] != 'e' && s[i - 1] != 'i' && s[i - 1] != 'o' && s[i - 1] != 'u')))
            ++sum;
    return sum;
}

int main() {
    std::ios::sync_with_stdio(false);
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector <ll> a(n);
    for (ll i = 0; i < n; ++i) {
        string s; cin >> s;
        a[i] = cnt_sl(s);
    }
    ll cnt = 0;
    deque <ll> d1, d2, d3;
    ll s1 = a[0], s2 = a[1], s3 = a[2];
    d1.push_back(a[0]);
    d2.push_back(a[1]);
    d3.push_back(a[2]);
    for (ll i = 3; i < n; ++i) {
        d3.push_back(a[i]);
        s3 += a[i];
        while (s3 > 5) {
            ll last = d3.front();
            d3.pop_front();
            s3 -= last;
            d2.push_back(last);
            s2 += last;
        }
        while (s2 > 7) {
            ll last = d2.front();
            d2.pop_front();
            s2 -= last;
            d1.push_back(last);
            s1 += last;
        }
        while (s1 > 5) {
            ll last = d1.front();
            d1.pop_front();
            s1 -= last;
        }
        if (s1 == 5 && s2 == 7 && s3 == 5)
            ++cnt;
    }
    cout << cnt;
}
