#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>
using namespace std;

template <typename T> inline T getint() {
    T val = 0;
    char c;
    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }
    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));
    return val * (neg ? -1 : 1);
}

typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}



int main() {
    std::ios::sync_with_stdio(false);
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll a, b;
    vector<pair<int, int>> ans;
    cin >> a >> b;
    while (true) {
        if (a == 0 || b == 0)
            break;
        if (a == b) {
            ans.push_back({ 1, -1 });
            break;
        }
        if (a == -b) {
            ans.push_back({ 1, 1 });
            break;
        }
        if (abs(a) > abs(b)) {
            ll k = a / b;
            if (k > 0 && abs(a - k * b) > abs(a - k * b - b))
                k++;
            if (k < 0 && abs(a - k * b) > abs(a - k * b + b))
                k--;
            a = a - k * b;
            ans.push_back({ 1, -k });
            continue;
        }
        if (abs(b) > abs(a)) {
            ll k = b / a;
            if (k > 0 && abs(b - k * a) > abs(b - k * a - a))
                k++;
            if (k < 0 && abs(b - k * a) > abs(b - k * a + a))
                k--;
            b = b - k * a;
            ans.push_back({ 2, -k });
            continue;
        }
    }
    cout << ans.size() << '\n';
    for (auto p : ans) {
        cout << p.first << ' ' << p.second << '\n';
    }
}
