#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>
using namespace std;

template <typename T> inline T getint() {
    T val = 0;
    char c;
    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }
    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));
    return val * (neg ? -1 : 1);
}

typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-10;
ll sum;
ll n, x, y;
vector <char> used;

void us(ll cnt_x, ll cnt_y, vector <ll> a, vector <ll> b) {
    while (cnt_x < x || cnt_y < y) {
        vector <pair <ll, ll>> deg(n);
        for (ll i = 0; i < n; ++i)
            deg[i] = { abs(a[i] - b[i]), i };
        sort(deg.begin(), deg.end());
        for (ll i = 0; i < n && (cnt_x < x || cnt_y < y); ++i) {
            if (used[deg[i].second] == 1) {
                --cnt_x;
                ++cnt_y;
                sum -= deg[i].first;
                used[deg[i].second] = 0;
            }
        }
    }
}

int main() {
    std::ios::sync_with_stdio(false);
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> x >> y;
    vector <ll> a(n);
    vector <ll> b(n);
    for (ll i = 0; i < n; ++i)
        cin >> a[i];
    for (ll i = 0; i < n; ++i)
        cin >> b[i];
    ll cnt_x = 0;
    ll cnt_y = 0;
    sum = 0;
    used.assign(n, 0);
    for (ll i = 0; i < n; ++i)
        if (a[i] < b[i]) {
            cnt_y++;
            sum += b[i];
        }
        else {
            cnt_x++;
            sum += a[i];
            used[i] = 1;
        }
    if (cnt_y < y) {
        us(cnt_x, cnt_y, a, b);
        cout << sum << '\n';
        for (ll i = 0; i < n; ++i)
            cout << (used[i] == 1 ? "T " : "P ");
        return 0;
    } 
    if (cnt_x < x) {
        for (ll i = 0; i < n; ++i) {
            swap(a[i], b[i]);
            if (used[i] == 1)
                used[i] = 0;
            else
                used[i] = 1;
        }
        swap(cnt_x, cnt_y);
        swap(x, y);
        us(cnt_x, cnt_y, a, b);
        cout << sum << '\n';
        for (ll i = 0; i < n; ++i)
            cout << (used[i] == 1 ? "P " : "T ");
        return 0;
    }
    cout << sum << '\n';
    for (ll i = 0; i < n; ++i)
        cout << (used[i] == 1 ? "T " : "P ");
}
