#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
    for (T i : vec) {
        os << i << ' ';
    }
    return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
    for (vector<T> i : vec) {
        os << i << '\n';
    }
    return os;
}


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(n + 1);
	vector<int> a(n + 1);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	int x;
	cin >> x;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	priority_queue<pair<int, int>> q;
	vector<int> d(n + 1);
	d[1] = a[1] < x ? x : x / 2;
	q.push({d[1], 1});
	while (!q.empty()) {
		auto[di, i] = q.top();
		q.pop();
		if (d[i] > di)
			continue;
		for (int to : g[i]) {
			if (a[to] >= di && d[to] < di / 2) {
				d[to] = di / 2;
				q.push({d[to], to});
			} else if (a[to] < di && d[to] < di) {
				d[to] = di;
				q.push({di, to});
			}
		}
	}
	cout << d[n] << '\n';
}

int32_t main() {
    start;

    solve();

    finish;
}