#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
	for (auto &i : vec) {
		is >> i;
	}
	return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
	for (T i : vec) {
		os << i << ' ';
	}
	return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
	for (vector<T> i : vec) {
		os << i << '\n';
	}
	return os;
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	cin >> a;
	cin >> b;
	int sa = 0, sb = 0;
	for (int i = 0; i < n; i++)
		sa ^= a[i];
	for (int i = 0; i < n; i++)
		sb ^= b[i];
	vector<int> used(n);
	vector<int> p(n);
	for (int i = 0; i < n; i++) {
		p[i] = i;
	}
	for (int _ = 0; _ < 10; _++) {
		random_shuffle(p.begin(), p.end());
		for (int i = 0; i < n; ++i) {
			int c = sa ^a[p[i]] ^b[p[i]];
			int d = sb ^a[p[i]] ^b[p[i]];
			if (c + d > sa + sb)
				sa = c, sb = d, used[p[i]] = 1;
		}
	}
	cout << sa + sb << " " << accumulate(used.begin(), used.end(), 0) << '\n';
	for (int i = 0; i < n; i++)
		if (used[i]) cout << i + 1 << " ";
	cout << '\n';
}

int32_t main() {
	start;
	
	solve();
	
	finish;
}