#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <random>
#include <functional>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

struct Tree {
    typedef int T;
    static constexpr T unit = INF;
    T f(T a, T b) { return min(a, b); } // (any associative fn)
    vector<T> s; int n;
    Tree(int n = 0, T def = unit) : s(2*n, def), n(n) {}
    void update(int pos, T val) {
        for (s[pos += n] = val; pos /= 2;)
            s[pos] = f(s[pos * 2], s[pos * 2 + 1]);
    }
    T query(int b, int e) { // query [b, e)
        T ra = unit, rb = unit;
        for (b += n, e += n; b < e; b /= 2, e /= 2) {
            if (b % 2) ra = f(ra, s[b++]);
            if (e % 2) rb = f(s[--e], rb);
        }
        return f(ra, rb);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    swap(n, m);

    vector<int> s(n), t(n), len(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i] >> t[i];
        --s[i], --t[i];
        len[i] = t[i] - s[i] + 1;
    }

    vector<vector<int>> dp(n, vector<int> (m, INF));
    Tree st(m);
    for (int j = len[0] - 1; j < m; j++) {
        dp[0][j] = abs(t[0] - j);
        st.update(j, dp[0][j]);
    }
    for (int i = 1; i < n; i++) {
        int len_prev = len[i - 1];
        for (int j = len[i] - 1; j < m; j++) {
            dp[i][j] = st.query(j - len[i] + 1, min(m, j + len_prev)) + abs(t[i] - j);
        }
        for (int j = 0; j < m; j++) {
            st.update(j, dp[i][j]);
        }
    }

    cout << *min_element(dp[n - 1].begin(), dp[n - 1].end());
}

signed main() {
    fast();
    solve();
    return 0;
}
