#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9;

struct SegTreeDown {
    int n;
    vector<int> tree;

    SegTreeDown(int _n) {
        n = _n;
        tree.assign(2 * n, 0);
    }

    void build(vector<int> &a) {
        for (int i = 0; i < n; ++i) {
            tree[i + n] = a[i];
        }
        for (int i = n - 1; i >= 1; --i) {
            tree[i] = min(tree[2 * i], tree[2 * i + 1]);
        }
    }

    void update(int i, ll val) {
        i += n;
        tree[i] = val;
        i /= 2;
        while (i != 0) {
            tree[i] = min(tree[2 * i], tree[2 * i + 1]);
            i /= 2;
        }
    }

    int get(int l, int r) { // [l, r)
        --r;
        l += n;
        r += n;
        int ans = INF;
        while (l <= r) {
            if (l % 2 == 1) {
                ans = min(ans, tree[l]);
                ++l;
            }
            if (r % 2 == 0) {
                ans = min(ans, tree[r]);
                --r;
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pii> a(m);
    vector<int> l(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i].first >> a[i].second;
        --a[i].first; --a[i].second;
        l[i] = a[i].second - a[i].first + 1;
    }
    vector<vector<int>> dp(m, vector<int> (n, INF));
    for (int i = 0; i + l[0] - 1 < n; ++i) {
        dp[0][i] = abs(a[0].first - i);
    }
    SegTreeDown t(n);
    for (int i = 1; i < m; ++i) {
        t.build(dp[i - 1]);
        for (int j = 0; j + l[i] - 1 < n; ++j) {
            int move = abs(a[i].first - j);
            int L = max(0, j - (l[i - 1] - 1)), R = j + l[i] - 1;
            dp[i][j] = min(INF, move + t.get(L, R + 1));
        }
    }
    t.build(dp[m - 1]);
    cout << t.get(0, n) << en;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}