#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;
const int MAXN = 2 * 1e5 + 2;
vector <int> g[MAXN];
vector <ll> a;

ll calcd(int dfrom, int to) {
    if (dfrom > a[to]) {
        return dfrom;
    }
    return (dfrom - (dfrom % 2)) / 2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
    #ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    #endif

    int n, m;
    cin >> n >> m;
    a.resize(n);

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    ll x;
    cin >> x;

    for (int i = 0; i < n; i++) cin >> a[i];

    vector <ll> d(n, 0);
    set <pair<ll, int>> s;

    d[0] = calcd(x, 0);
    s.insert({d[0], 0});

    while (!s.empty()) {
        ll dst = (--s.end())->first, v = (--s.end())->second;
        if (v == n - 1) break;

        s.erase(--s.end());

        for (auto to: g[v]) {
            ll weight = calcd(dst, to);
            if (d[to] < weight) {
                s.erase({d[to], to});
                d[to] = weight;
                s.insert({d[to], to});
            }
        }
    }

    cout << d[n - 1] << '\n';
}