#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

ll mask = 0;
struct Node {
    Node* l = nullptr;
    Node* r = nullptr;
    int ind = -1;
    Node() = default;
};

void add(Node* v, int ind, int i = 0) {
    if (i == 60) {
        if(v->ind == -1)
            v->ind = ind;
        return;
    }
    bool t = (((1ll << (59 - i)) & mask) != 0);
    if (t) {
        if (v->r == nullptr)
            v->r = new Node();
        add(v->r, ind, i + 1);
    }
    else {
        if (v->l == nullptr)
            v->l = new Node();
        add(v->l, ind, i + 1);
    }
}
int get(Node* v, int i = 0) {
    if (v->l == nullptr && v->r == nullptr)
        return v->ind;
    bool t = (((1ll << (59 - i)) & mask) != 0);
    if ((t && v->l != nullptr) || v->r == nullptr) {
        return get(v->l, i + 1);
    }
    else {
        mask ^= (1ll << (59 - i));
        return get(v->r, i + 1);
    }
}

void solve() {
    int n; cin >> n;
    vector<ll>x(n);
    ll A = 0, B = 0;
    for (auto& i : x) {
        cin >> i;
        A ^= i;
    }
    for (int i = 0; i < n; i++) {
        ll b; cin >> b;
        B ^= b;
        x[i] ^= b;
    }
    ll out = 0, mask_down = 0;
    for (int i = 0; i < 60; i++) {
        if ((A & (1ll << i)) != (B & (1ll << i))) {
            out += (1ll << i);
            mask_down |= (1ll << i);
        }
    }
    mask_down = ~mask_down;
    A &= mask_down;
    B &= mask_down;
    for (int i = 0; i < n; i++) {
        x[i] &= mask_down;
    }
    vector<int>pr(n + 1, -1);
    mask = A;
    Node* root = new Node();
    add(root, 0);
    for (int i = 1; i <= n; i++) {
        mask = x[i - 1];
        pr[i] = get(root);
        add(root, i);
    }
    mask = 0;
    int start = get(root);
    cout << 2 * mask + out << ' ';
    vector<int>inds;
    while (start != 0) {
        inds.push_back(start);
        start = pr[start];
    }
    reverse(inds.begin(), inds.end());
    cout << inds.size() << '\n';
    for (auto i : inds)
        cout << i << ' ';
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    while (t--) {
        solve();
    }
}