#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

ld x; 
ld t, t3, t6, eps = 1e-20;

ld get3(ld sleep) {
    ld dop = 100 * sleep / t3;
    return (t - sleep) * dop;
}
ld get6(ld sleep) {
    ld dop = x * sleep / t6;
    return (t - sleep) * dop;
}

void solve() {
    cin >> x >> t;
    t3 = t / 3;
    t6 = t / 6;
    ld l = 0, r = t6, ans = -1;
    for (int i = 0; i < 100000; i++) {
        ld m1 = l + (r - l) / 3.0, m2 = r - (r - l) / 3.0;
        ld ans1 = get6(m1), ans2 = get6(m2);
        if (ans1 - ans2 <= eps)
            l = m1;
        else
            r = m2;
    }
    ans = max(ans, max(get6(l), get6(r)));
    l = t6, r = t3;
    for (int i = 0; i < 100000; i++) {
        ld m1 = l + (r - l) / 3.0, m2 = r - (r - l) / 3.0;
        ld ans1 = get3(m1), ans2 = get3(m2);
        if (ans1 - ans2 <= eps)
            l = m1;
        else
            r = m2;
    }
    ans = max(ans, max(get3(l), get3(r)));
    cout << setprecision(10) << fixed << ans;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    while (t--) {
        solve();
    }
}