#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <utility>
#include <queue>
#include <cmath>
#include <cstdlib>

#define fori(a, b) for(int i = a; i < b; ++i)
#define forj(a, b) for(int j = a; j < b; ++j)
#define fork(a, b) for(int k = a; k < b; ++k)
#define forn(n) for(int i = 0; i < n; ++i)
#define X first
#define Y second
#define mp make_pair

using namespace std;

typedef long long ll;         
typedef long double ld;         
typedef unsigned long long ull;

vector<int> dist, used, a;
vector<vector<int> > g;

void bfs(int x) {
    priority_queue<pair<int, int> > q;
    dist[0] = a[0] < x ? x : x / 2;
    q.push(mp(dist[0], 0));
    int v;
    pair<int, int> e;
    while (!q.empty()){
	e = q.top();
	v = e.Y;
	q.pop();
	if (used[v]) continue;
	used[v] = 1;
	for (int u : g[v]){
	    if (used[u]) continue;
	    dist[u] = max(dist[u], (int)(dist[v] / (int)(2 - (a[u] < dist[v]))));
	    q.push(mp(dist[u], u));
	}
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, v, u;
    cin >> n >> m;
    dist.resize(n), used.resize(n), a.resize(n);
    g.resize(n, vector<int>());
    forn(m) {
	cin >> v >> u, v--, u--;
	g[v].push_back(u);
	g[u].push_back(v);
    }
    int x; cin >> x;
    forn(n) cin >> a[i];
    bfs(x);
    cout << dist.back() << endl;
//    forn(n) cout << dist[i] << ' ';
    return 0;
}