#include<iostream>
#include<string>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<fstream>
#include<algorithm>
#include<cmath>
#include<iomanip>

#define ll long long

const int INF = 1e9 + 10;

using namespace std;

int n;

vector <ll> s, v;

map <pair <ll, ll>, map <pair <ll, ll>, ll>> on_line_at;

map <pair <ll, ll>, ll> perm;

ll gcd(ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

void check_on_line(ll i1, ll i2, ll i3) {
	ll numer = (i1 - i3) * (s[i1] - s[i2]) - (i1 - i2) * (s[i1] - s[i3]);
	ll denom = (v[i2] - v[i1]) * (i1 - i3) - (v[i3] - v[i1]) * (i1 - i2);
	if (v[i1] == v[i2] && v[i2] == v[i3]) {
		if (numer == 0) {
			++perm[{i1, i2}];
		}
		return;
	}
	if (numer < 0) {
		numer *= -1;
		denom *= -1;
	}
	if (denom < 0)
		return;
	if (denom == 0) {
		++perm[{i1, i2}];
		return;
	}
	ll d = gcd(numer, denom);
	numer /= d;
	denom /= d;
	++on_line_at[{i1, i2}][{numer, denom}];
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	s.resize(n);
	v.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> s[i] >> v[i];
	if (n == 1) {
		cout << 1;
		return 0;
	}
	for (int i1 = 0; i1 < n; ++i1)
		for (int i2 = i1 + 1; i2 < n; ++i2)
			for (int i3 = i2 + 1; i3 < n; ++i3)
				check_on_line(i1, i2, i3);
	ll answer = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			long long pr = perm[{i, j}];
			for (auto& el : on_line_at[{i, j}])
				answer = max(answer, pr + el.second);
		}
	}
	cout << answer + 2;
}


