#include <iostream>
#include <cmath>
#include <algorithm>
#include <queue>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <stack>
#include <iomanip>
#include <cstring>
#include <string>
#include <cstdio>

using namespace std;

int n;

const int MAXN = (int)1e5 + 20;

string s[MAXN];
int c[MAXN], pref[MAXN];

bool isvowel(char it)
{
    return it == 'a' || it == 'e' || it == 'i' || it == 'o' || it == 'u';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];

        int cur = 0, cnt = 0;

        for (auto it: s[i])
        {
            if (isvowel(it))
                ++cur;
            else
            {
                if (cur > 0)
                    ++cnt;
                cur = 0;
            }
        }
        if (cur > 0)
            ++cnt;

        c[i] = cnt;
        pref[i] = pref[i - 1] + c[i];
    }

    int ans = 0;

    for (int i = 1; i + 2 <= n; ++i)
    {
        int l = i - 1, r = n + 1;

        while (l < r - 1)
        {
            int mid = (l + r) >> 1;
            if (pref[mid] - pref[i - 1] > 5)
                r = mid;
            else
                l = mid;
        }

        if (pref[l] - pref[i - 1] == 5 && l + 1 < n)
        {
            int l1 = l, r1 = n + 1;

            while (l1 < r1 - 1)
            {
                int mid = (l1 + r1) >> 1;
                if (pref[mid] - pref[l] > 7)
                    r1 = mid;
                else
                    l1 = mid;
            }

            if (pref[l1] - pref[l] == 7 && l1 < n)
            {
                int l2 = l1, r2 = n + 1;

                while (l2 < r2 - 1)
                {
                    int mid = (l2 + r2) >> 1;
                    if (pref[mid] - pref[l1] > 5)
                        r2 = mid;
                    else
                        l2 = mid;
                }

                if (pref[l2] - pref[l1] == 5)
                    ++ans;
            }
        }
    }

    cout << ans;

    return 0;
}
