#include <algorithm>
#include <cmath>
#include <iostream>
#include <queue>
#include <vector>

using namespace std;
using ll = long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  ll n, m;
  cin >> n >> m;

  vector<vector<ll>> graph(n + 1);
  for (ll i = 0; i < m; i++) {
    ll a, b;
    cin >> a >> b;

    graph[a].push_back(b);
  }

  ll x;
  cin >> x;

  vector<ll> a(n);
  for (ll i = 0; i < n; i++)
    cin >> a[i];

  vector<bool> visited(n + 1);
  fill_n(visited.begin(), n + 1, false);

  visited[1] = true;
  vector<ll> values(n + 1);
  fill_n(values.begin(), n + 1, -1);

  values[1] = (x > a[0] ? x : x / 2);
  queue<ll> deque;

  deque.push(1);
  while (!deque.empty()) {
    ll v = deque.front();
    deque.pop();

    for (size_t i = 0; i < graph[v].size(); i++) {
      ll to = graph[v][i];
      ll cnt = a[to - 1];

      if (values[v] > cnt && !visited[to])
        values[to] = values[v], visited[to] = true, deque.push(to);
      else if (values[v] <= cnt && !visited[to])
        values[to] = values[v] / 2, visited[to] = true, deque.push(to);
      else if (values[v] > cnt && visited[to])
        values[to] = max(values[v], values[to]);
      else if (values[v] <= cnt && visited[to])
        values[to] = max(values[v] / 2, values[to]);
    }
  }

  cout << (values[n] == -1 ? 0 : values[n]);
}