#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;
using ull = unsigned long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  vector<ull> memo;
  for (auto i = 1; i <= ceil(sqrt(1e11)); i++)
    memo.push_back(i * i);

  ull a, b;
  cin >> a >> b;

  auto low = lower_bound(memo.begin(), memo.end(), a);
  auto up = upper_bound(memo.begin(), memo.end(), b);

  auto low_index = (low - memo.begin()), up_index = (up - memo.begin());

  ull ans = 0;
  for (auto i = low_index; i <= up_index; i++) {
    ull curr = memo[i];
    if (curr < a || curr > b || curr % 10 == 0)
      continue;

    ull reversed = 0;
    while (curr > 0) {
      reversed = reversed * 10 + curr % 10;
      curr /= 10;
    }

    if (reversed < a || reversed > b || reversed % 10 == 0)
      continue;

    ull root = static_cast<ull>(sqrt(reversed));
    ans += (root * root == reversed);
  }

  cout << ans;
}