#if 1

#define DEBUG 0

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

#if DEBUG
int runs = 1;
ifstream input("ProblemI/in.txt");
ofstream output("ProblemI/out.txt");
#else
int runs = 1;
istream& input = std::cin;
ostream& output = std::cout;
#endif

const int INF = (int)1e9;

struct Exam
{
	int c;
	int ind;
};

struct Diff
{
	int c;
	int ind;
};


int main()
{
	while (runs-- > 0)
	{
		int n, a, b;
		input >> n >> a >> b;

		vector<Exam> T(n);
		vector<Exam> P(n);
		vector<Diff> diff(n);
		vector<int> ans(n);

		for (int i = 0; i < n; i++)
		{
			input >> T[i].c;
			T[i].ind = i;
		}

		for (int i = 0; i < n; i++)
		{
			input >> P[i].c;
			P[i].ind = i;
		}

		for (int i = 0; i < n; i++)
		{
			diff[i].c = abs(T[i].c - P[i].c);
			diff[i].ind = i;
		}

		sort(diff.begin(), diff.end(), [](Diff& A, Diff& B) {return A.c < B.c; });

		int res = 0;


		for (int i = a + b; i < diff.size(); i++)
		{
			if (P[diff[i].ind].c > T[diff[i].ind].c)
			{
				ans[i] = 1;
				res += P[diff[i].ind].c;
			}
			else
			{
				ans[i] = 0;
				res += T[diff[i].ind].c;
			}
		}

		vector<Diff> diff2(a + b);
		for (int i = 0; i < a + b; i++)
		{
			diff2[i].c = P[diff[i].ind].c - T[diff[i].ind].c;
			diff2[i].ind = diff[i].ind;
		}

		sort(diff2.begin(), diff2.end(), [](Diff& A, Diff& B) {return A.c < B.c; });

		for (int i = 0; i < a; i++)
		{
			ans[diff2[i].ind] = 0;
			res += T[diff2[i].ind].c;
		}

		for (int i = a; i < a + b; i++)
		{
			ans[diff2[i].ind] = 1;
			res += P[diff2[i].ind].c;
		}

		output << res << "\n";
		for (int i = 0; i < ans.size(); i++)
			output << (ans[i] == 0 ? "T" : "P") << (i == ans.size() - 1 ? "\n" : " ");
	}

	return 0;
}


#endif
