#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
  cin.tie(nullptr);
  cout.tie(nullptr);
  ios::sync_with_stdio(false);
  cin.exceptions(ios::failbit);
}

db gss(db a, db b, auto f) {
  db r = (sqrtl(5) - 1) / 2, eps = 1e-7;
  db x1 = b - r * (b - a), x2 = a + r * (b - a);
  db f1 = f(x1), f2 = f(x2);
  while (b - a > eps)
    if (f1 > f2) {
      b = x2; x2 = x1; f2 = f1;
      x1 = b - r * (b - a);
      f1 = f(x1);
    } else {
      a = x1; x1 = x2; f1 = f2;
      x2 = a + r * (b - a);
      f2 = f(x2);
    }
  return a;
}

inline void solve() noexcept {
  db x, T;
  cin >> x >> T;


  db ans = (T - T / 3) * 100;
  auto f1 = [&](db t) -> db {
    double workX = (100 - x) / (T / 6) * t + x;
    return workX * (T - (t + T / 6));
  };

  db x1 = gss(0, T / 6, f1);
  ans = max(ans, f1(x1));

  auto f2 = [&](db t) -> db {
    double workX = (x - 0) / (T / 6) * t;
    return workX * (T - t);
  };

  db x2 = gss(0, T / 6, f1);
  ans = max(ans, f2(x2));

  cout << fixed << setprecision(15) << ans << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  fastio();
  int tt = 1;
  // cin >> tt;
  while (tt-- > 0)
    solve();
  return 0;
}
