﻿#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <set>
#include <iostream>

typedef long long ll;

using namespace std;

const ll INF = 1e18;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll n, m, x;

    cin >> n >> m;

    vector<vector<pair<ll, ll>>> v(n);

    for (int i = 0; i < m; i++) {
        ll from, to;
        cin >> from >> to;
        from--; to--;
        v[from].push_back({ to, 0 });
        v[to].push_back({ from, 0 });
    }
    cin >> x;
    for (int i = 0; i < n; i++) {
        ll y;
        cin >> y;
        v[i][0].second = y;
        v[v[i][0].first][0].second = y;
    }
    vector<ll> dp(n,INF);
    vector<ll> pred(n);

    dp[0] = 0;
    set<pair<ll, ll>> q;
    q.insert({ dp[0], 0 });
    while (!q.empty()) {
        ll p = q.begin()->second;
        q.erase(q.begin());
        for (int j = 0; j < v[p].size(); j++) {
            ll to = v[p][j].first, cost = v[p][j].second;
            if (dp[p] + cost < dp[to]) {
                q.erase({ dp[to], to });
                dp[to] = dp[p] + cost;
                pred[to] = p;
                q.insert({ dp[to], to });
            }
        }
    }
    vector<ll> puff;
    for (int i = n - 1; i != 0; i = pred[i]) {
        puff.push_back(i);
    }
    puff.push_back(0);
    reverse(puff.begin(), puff.end());
    for (int i = 0; i < puff.size(); i++) {
        ll cost = v[i][0].second;
        if (x <= cost) x = x - ((x)/2);
    }
    if (x < 0) cout << 0;
    else cout << x;
}